# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es

import re
import os
import random

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


informations = es.AddonInfo()
informations["name"] = "Parachute by L'In20Cible"
informations["version"] = "1.2"
informations["date"] = "2010-05-08"
informations["author"] = "L\'in20Cible"
informations["url"] = "http://addons.eventscripts.com/addons/view/parachute/"
informations["basename"] = "parachute"

es.ServerVar("pc_version", (informations["version"] + " by " + informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


options = {
   "enable": ("1", "pc_enable <1/0> -- Active/Désactive le parachute."),
   "admins": ("0", "pc_admins <1/0> -- Active/Désactive la restriction du parachute aux joueurs qui ne sont pas administrateurs."),
   "models": ("0", "pc_models <1/0> -- Active/Désactive les apparences du parachute.")
   }
for option in options:
   options[option] = es.ServerVar(("pc_" + option), options[option][0], options[option][1])
   
   
# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   Initialization()
   es.addons.registerTickListener(TickListenerCallBack)
   
   
def Initialization():
   global admins, models, players
   path = GetConfigurationFilePath("configuration.cfg")
   if os.path.isfile(path):
      es.mexec(path.replace(str(es.ServerVar("eventscripts_gamedir")).replace(os.sep, "/"), ".."))
   admins = GetConfigurationFileParsed(GetConfigurationFilePath("admins.txt"))
   models = GetConfigurationFileParsed(GetConfigurationFilePath("models.txt"))
   players = list()
   if (str(es.ServerVar("eventscripts_currentmap")) == ""):
      return
   for line in GetConfigurationFileParsed(GetConfigurationFilePath("downloads.txt")):
      if not os.path.isfile(os.path.join(str(es.ServerVar("eventscripts_gamedir")), line)):
         continue
      es.stringtable("downloadables", line)
      
      
def unload():
   es.addons.unregisterTickListener(TickListenerCallBack)
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetConfigurationFilePath(file):
   return os.path.join(es.getAddonPath(informations["basename"]), "configuration", file).replace(os.sep, "/")
   
   
def GetConfigurationFileParsed(path):
   lines = list()
   if not os.path.isfile(path):
      return lines
   regex = re.compile("//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\n)+")
   for line in open(path):
      line = regex.sub("", line).strip()
      if not line:
         continue
      lines.append(line)
   return lines
   
   
def SetPlayerParachuteLocation(userid, origin):
   es.server.queuecmd("es_xfire %i parachute_%i addoutput \"origin %s %s %s\"" % (userid, userid, origin[0], origin[1], origin[2]))
   
   
def OpenPlayerParachute(userid):
   if not int(options["models"]) or not len(models):
      return
   for x in (
      "es_xprop_physics_create %i props/cs_office/water_bottle.mdl" % userid,
      "es est_setentname server_var(eventscripts_lastgive) parachute_%i" % userid,
      #"es_entsetname %i parachute_%i" % userid,
      #"es_xfire %i !picker addoutput \"targetname parachute_%i\"" % (userid, userid),
      #"es setentname server_var(eventscript_lastgive) parachute_%i" % (userid, userid),
      "es_setindexprop server_var(eventscripts_lastgive) \"CBaseEntity.m_nModelIndex\" %i" % es.precachemodel(random.choice(models)),
      "es_setindexprop server_var(eventscripts_lastgive) \"CBaseEntity.m_clrRender\" -1",
      "es_setindexprop server_var(eventscripts_lastgive) \"CBaseEntity.m_CollisionGroup\" 2",
      "es_setindexprop server_var(eventscripts_lastgive) \"CBaseEntity.movetype\" 0"): es.server.queuecmd(x)
   SetPlayerParachuteLocation(userid, es.getplayerlocation(userid))
   
   
def ClosePlayerParachute(userid):
   es.server.queuecmd("es_xfire %i parachute_%i kill" % (userid, userid))
   
   
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def TickListenerCallBack():
   if not int(options["enable"]):
      return
   for x in es.getUseridList():
      if es.getplayerprop(x, "CCSPlayer.pl.deadflag") or (int(options["admins"]) and not (es.getplayersteamid(x) in admins)):
         continue
      if x not in players:
         if (es.getplayerprop(x, "CCSPlayer.baseclass.localdata.m_Local.m_flFallVelocity") > 0.0) and (es.getplayerprop(x, "CBaseEntity.movetype") <> -65527):
            players.append(x)
            es.server.queuecmd("es_xfire %i !self ADDOUTPUT \"gravity 0.1\"" % x)
            OpenPlayerParachute(x)
      else:
         if (es.getplayerprop(x, "CCSPlayer.baseclass.localdata.m_hGroundEntity") <> -1) or (es.getplayerprop(x, "CBaseEntity.movetype") == -65527):
            players.remove(x)
            es.server.queuecmd("es_xfire %i !self ADDOUTPUT \"gravity 1.0\"" % x)
            ClosePlayerParachute(x)
         else:
            SetPlayerParachuteLocation(x, es.getplayerlocation(x))
            
            
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def es_map_start(event_var):
   Initialization()
   
   
def player_death(event_var):
   ClosePlayerParachute(int(event_var["userid"]))
   
   
def player_disconnect(event_var):
   ClosePlayerParachute(int(event_var["userid"]))